(* ****************************************************************
*
*     MAIN -- Entries to Mathematica code from C code.
*
**************************************************************** *)

Begin[ "Integrate`"]

General::intinit = "Loading integration packages."

Message[ General::intinit]

Unprotect[Definite]

Clear[ Definite]

Definite[$f_,$xmin_,$xmax_]:=
  (* Definite integration. *)
  Block[{$answer},
    TrcEnter[Definite,$f,$xmin,$xmax];
    (* Call Victor's code. *)
    $answer=IntegrateG[$f,{X,$xmin,$xmax}];
    If[Not[FreeQ[$answer,IntegrateG]],
       $answer=NOK];
    TrcExit[Definite,$answer];
    $answer]
    
Get[ "Integrate`inputrules`"]
Get[ "Integrate`logcases`"]
Get[ "Integrate`mainalgorithm`"]
Get[ "Integrate`taylorseries`"]
Get[ "Integrate`theoremslater`"]

Protect[Definite]

End[]

Null


